<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: Shop.template.php
//      Template file for Shop
 
// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: Shop.template.php 24 2006-10-21 03:34:18Z daniel15 $

// Yes, I know that this should use layers instead of a header and footer.
// However, when I originally programmed it, I didn't have any idea about what layers actually were.
// I don't really have the time to rewrite this so it uses the layer system...

// The header. Shown at the 'top' of every shop page.
// I use 'top' loosely, as it's actually the menu on the left
function shop_header() {
	global $txt, $context, $modSettings, $scripturl, $settings;

	echo '
		<!-- The Linktree -->
		<table width="100%" cellpadding="3" cellspacing="0"><tr><td valign="bottom">', theme_linktree(), '</td></tr></table>
		<table width="100%" cellpadding="0" cellspacing="0" border="0" style="padding-top: 1ex;"><tr>
			<td width="180" valign="top" style="width: 26ex; padding-right: 10px; padding-bottom: 10px;">
				<table width="100%" cellpadding="4" cellspacing="1" border="0" class="bordercolor">
					<tr>
						<td class="catbg">', $txt['shop'], ' Stuff</td>
					</tr>
					<tr class="windowbg2">
						<td class="smalltext" style="line-height: 1.3; padding-bottom: 3ex;">
							<a href="', $scripturl, '?action=shop">', $txt['shop'], ' Home</a><br />
							<a href="', $scripturl, '?action=shop;do=buy">', $txt['shop_buy'], '</a><br />
							<a href="', $scripturl, '?action=shop;do=inv">', $txt['shop_yourinv'], '</a><br />
							<a href="', $scripturl, '?action=shop;do=sendmoney">', $txt['shop_send_money'], '</a><br />
							<a href="', $scripturl, '?action=shop;do=senditems">', $txt['shop_send_item'], '</a><br />
							<a href="', $scripturl, '?action=shop;do=invother">', $txt['shop_invother'], '</a><br />
							', $context['shop_trade_link'], '
							', $context['shop_bank_link'], '
						</td>
					</tr>
				</table>
			</td>
			<td valign="top">';
}

// Likewise, this is the footer at the bottom of each page
function shop_footer() {
	global $txt, $context, $modSettings, $scripturl, $settings, $sourcedir;
	
	//Get the SMFShop version information (file only loaded if not loaded previously)
	require_once("{$sourcedir}/shop/shopVersion.php");
	
	echo '
		</td></tr></table>
		<p align="right">Powered by SMFShop ', $shopVersion['version'], '(Build ', $shopVersion['build'], '), &copy; 2005, 2006 <a href="http://www.dansoftaustralia.net/">DanSoft Australia</a><br />';
	
	// If this SMFShop version is a development (unreleased) version
	if ($shopVersion['develVersion'] == true) {
		echo "<i>Development version!</i> {$shopVersion['SVNid']} ({$shopVersion['SVNdate']})";
	}
	
	echo '</p>';
}

// The main shop page (ie. the index)
function template_main(){
	global $txt, $context, $modSettings, $scripturl, $settings;
	
	// Show the header
	shop_header();
	echo '
			<table width="100%" cellpadding="5" cellspacing="1" border="0" class="bordercolor">
				<tr class="titlebg">
					<td align="center" colspan="2" class="largetext">', $txt['shop'], '</td>
				</tr><tr>
					<td class="windowbg" valign="top" style="padding: 7px;">
						<b>', $txt['shop_welcome'], '</b>
						<div style="font-size: 0.85em; padding-top: 1ex;">', $txt['shop_welcome_full'], '
						<br /><br />
						<b>', $txt['shop_per_new_topic'], ': </b> ', $context['shop_newtopic'], '<br />
						<b>', $txt['shop_per_new_post'], ': </b>', $context['shop_newpost'], '<br />
						', $context['shop_bank_info'], '
						<br />
						<b>', $txt['shop_money_in_pocket'], ': </b>', $context['shop_money'], '<br />
						', $context['shop_money_in_bank'], '
						</div>
					</td>
				</tr>
			</table>
			<table width="100%" cellpadding="0" cellspacing="0" border="0" style="margin-top: 1.5ex;"><tr>
				<td valign="top">
					<table width="100%" cellpadding="5" cellspacing="1" border="0" class="bordercolor">
						<tr><td class="catbg">', $txt['shop_richest_pocket'], '</td></tr>
						<tr>
							<td class="windowbg2" valign="top" style="height: 18ex;">
								', $context['shop_richest'], '<br />
								<a href="', $scripturl, '?action=shop;do=viewall">', $txt['shop_view_all'], '</a>
							</td>
						</tr>
					</table>
				</td>';

	// If the bank's enabled
	if ($modSettings['shopBankEnabled']) {
		echo '
				<td style="width: 1ex;">&nbsp;</td>
				<td valign="top" style="width: 50%;">
			<table width="100%" cellpadding="5" cellspacing="1" border="0" class="bordercolor" id="supportVersionsTable">
				<tr>
					<td class="catbg">', $txt['shop_richest_bank'], '</td>
				</tr><tr>
					<td class="windowbg2" valign="top" style="height: 18ex;">
						', $context['shop_richestBank'], '<br />
						 <a href="', $scripturl, '?action=shop;do=viewallBank">', $txt['shop_view_all'], '</a>
					</td>
				</tr>';
	}

	// Close the table
	echo "</table></td></tr></table>";
	// And show the footer
	shop_footer();
}

// Inventory page.
// Used in various places - The shop 'Buy Stuff' page, your inventory page, etc.
function template_inventory() {
	global $txt, $context, $modSettings, $scripturl, $settings;
	
	shop_header();
	echo '
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
		', $context['shop_items_list'];

	// If this listing should have paging at the bottom
	if (isset($context['shop_current_page']) && isset($context['shop_pages'])) {
		echo '<tr><td colspan="4" align="right">Pages: ';
		
		//If current page != 1, show '< Back' link
		if ($context['shop_current_page'] != 1) {
			$prevPage = $context['shop_current_page'] - 1;
			echo "<a href='{$context['shop_page_link']};page={$prevPage}'>{$txt['shop_back']}</a> ";
		} else {
			echo $txt['shop_back']." ";
		}
		
		// Show links to all pages
		for ($x = 1; $x <= $context['shop_pages']; $x++) {
			// If this number is the current page, don't make number a link
			if ($x == $context['shop_current_page']) {
				echo "<b>$x</b> ";
			} else {
				echo "<a href='{$context['shop_page_link']};page={$x}'>$x</a> ";			
			}
		}
		
		// If current page != last page, show 'Next >' link
		if ($context['shop_current_page'] != $context['shop_pages']) {
			$nextPage = $context['shop_current_page'] + 1;
			echo "<a href='{$context['shop_page_link']};page={$nextPage}'>{$txt['shop_next2']}</a> ";
		} else {
			echo $txt['shop_next2']." ";
		}
	
		echo '</td></tr>';
	}
	
	// Close the table
	echo '</table>';
	// And show the footer
	shop_footer();
}

// Probably the simplest template. This one simply shows a message to the user.
// Used almost everywhere :)
function template_message() {
	global $txt, $context, $modSettings, $scripturl, $settings;
	
	shop_header();
	echo '
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
			<tr valign="top" class="windowbg2">
				<td style="padding-bottom: 2ex;" width="20%">
					', $context['shop_buy_message'], '
				</td>
			</tr>
		</table>';

	shop_footer();
}

// Send money to someone page
function template_sendMoney() {
	global $txt, $context, $modSettings, $scripturl, $settings;
	
	shop_header();
	echo '
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
			<tr valign="top" class="windowbg2">
				<td style="padding-bottom: 2ex;" width="20%">
					<center><b>', $txt['shop_send_money'], '</b></center><br />', $txt['shop_send_money_message'], '
					<form action="', $scripturl, '?action=shop;do=sendmoney2" method="post">
						', $txt['shop_member_name'], ': <input type="text" name="membername" size="25" value="', $context['shopSendMoneyMember'], '" />
						<a href="', $scripturl, '?action=findmember;input=membername;quote=1;sesc=', $context['session_id'], '" onclick="return reqWin(this.href, 350, 400);"><img src="', $settings['images_url'], '/icons/assist.gif" border="0" alt="', $txt['find_members'], '" /> Find Members</a><br />
			
						', $txt['shop_amount_to_send'], ':
							', $modSettings['shopCurrencyPrefix'], '
							<input type="text" name="amount" size="8" />
							', $modSettings['shopCurrencySuffix'], '<br />
						', $txt['shop_send_message_to_give'], ': <textarea name="message" cols="50" rows="5" style="width: 100%"></textarea><br />
						<input type="submit" value="', $txt['shop_send_money'], '" />
					</form>
				</td>
			</tr>
		</table>';
	shop_footer();
}

// Main bank page
function template_bank() {
	global $txt, $context, $modSettings, $scripturl, $settings;
	
	shop_header();
	echo '
		<table width="100%" cellpadding="5" cellspacing="1" border="0" class="bordercolor">
			<tr class="titlebg">
				<td align="center" colspan="2" class="largetext">', $txt['shop'], ' ', $txt['shop_bank'], '</td>
			</tr><tr>
				<td class="windowbg" valign="top" style="padding: 7px;">
					<b>', $txt['shop_bank_welcome'], '</b>
					<div style="font-size: 0.85em; padding-top: 1ex;">', $txt['shop_bank_welcome_full'], '<br /><br />
					', $txt['shop_bank_minDeposit'], ': ', $modSettings['shopCurrencyPrefix'], $modSettings['shopMinDeposit'], $modSettings['shopCurrencySuffix'], '<br />
					', $txt['shop_bank_minWithdraw'], ': ', $modSettings['shopCurrencyPrefix'], $modSettings['shopMinWithdraw'],  $modSettings['shopCurrencySuffix'], '</div>
					 
				</td>
			</tr>
		</table>
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
			<tr valign="top" class="windowbg2">
				<td style="padding-bottom: 2ex;" width="20%">
					', $context['shop_bank_message'], '<br /><br />
					<form action="', $scripturl, '?action=shop;do=bank2" method="post">
						  <input type="radio" name="type" value="deposit" checked="checked" />', $txt['shop_bank_deposit'], '
						  <input type="radio" name="type" value="withdraw" />', $txt['shop_bank_withdraw'], '<br />
						  ', $txt['shop_amount'], ': ', $modSettings['shopCurrencyPrefix'], ' <input type="text" name="amount" size="5" /> ', $modSettings['shopCurrencySuffix'], '<br />
						  <input type="submit" value="Go!" />
					</form>
				</td>
			</tr>
		</table>';
	shop_footer();
}

// Viewing someone else's inventory
// Step 1 - Enter their name
function template_otherInventory() {
	global $txt, $context, $modSettings, $scripturl, $settings;
	
	shop_header();
	echo '
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
			<tr valign="top" class="windowbg2">
				<td style="padding-bottom: 2ex;" width="20%">
					<div align="center"><b>', $txt['shop_invother'], '</b></div><br />', $txt['shop_invother_message'], '<br />
					<form action="', $scripturl, '?action=shop;do=invother2" method="post">
						', $txt['shop_member_name'], ':
				  
						<input type="text" name="member" size="25" />
						<a href="', $scripturl, '?action=findmember;input=member;quote=0;sesc=', $context['session_id'], '" onclick="return reqWin(this.href, 350, 400);"><img src="', $settings['images_url'], '/icons/assist.gif" border="0" alt="', $txt['find_members'], '" /> Find Members</a><br />
						<input type="submit" value="', $txt['shop_invother'], '" />
					</form>
				</td>
			</tr>
		</table>';
	shop_footer();
}

// The trade centre
function template_userTrade() {
	global $txt, $context, $modSettings, $scripturl, $settings;
	
	shop_header();
	echo '
		<table width="100%" cellpadding="5" cellspacing="1" border="0" class="bordercolor">
			<tr class="titlebg">
				<td align="center" colspan="2" class="largetext">', $txt['shop'], ' ', $txt['shop_trade'], '</td>
			</tr><tr>
				<td class="windowbg" valign="top" style="padding: 7px;">
					<b>', $txt['shop_trade_welcome'], '</b>
					<div style="font-size: 0.85em; padding-top: 1ex;">', $txt['shop_trade_welcome_full'], '</div>
				</td>
			</tr>
		</table>
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
			<tr valign="top" class="windowbg2">
				<td style="padding-bottom: 2ex;" width="20%">
					', $txt['shop_trade_list'], '<br /><br />
					<table width="100%" cellpadding="5" cellspacing="0" border="0">
						<tr valign="top" class="windowbg">
							<td style="padding-bottom: 2ex;" width="32">
								<b>', $txt['shop_image'], '</b>
							</td>
							<td>
								<b>', $txt['shop_name'], '</b>
							</td>
							<td>
								<b>', $txt['shop_description'], '</b>
							</td>
							<td width="18%">
								<b>', $txt['shop_price'], '</b>
							</td>
						</tr>
						', $context['shop_trade_list'], '
					</table>
		
					<br />', $txt['shop_wanna_trade'], '
				</td>
			</tr>
		</table>';
	shop_footer();
}

// Trade an item in the trade centre
function template_tradeItem() {
	global $txt, $context, $modSettings, $scripturl, $settings;
	
	shop_header();
	echo '
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
			<tr valign="top" class="windowbg2">
				<td style="padding-bottom: 2ex;" width="20%">
				  <div align="center"><b>', $txt['shop_tradeitem'], '</b></div>
				  <form action="', $scripturl, '?action=shop;do=trade_sell2" method="post">
					<input type="hidden" name="id" value="', $_GET['id'], '">
					', $txt['shop_price'], ': <input type="text" name="sellfor" value="', $context['shop_paid'], '" />
					<input type="submit" value="', $txt['shop_next'], '" /><br /><br />
					', $txt['shop_trade_message'], '
				</td>
			</tr>
		</table>';
	shop_footer();
}

// Send an item to somewhere
function template_sendItems() {
	global $txt, $context, $modSettings, $scripturl, $settings;
	
	shop_header();
	echo '
		<table width="100%" cellpadding="5" cellspacing="0" border="0" class="tborder" style="margin-top: 1.5ex;">
			<tr valign="top" class="windowbg2">
				<td style="padding-bottom: 2ex;" width="20%">
					<div align="center"><b>', $txt['shop_send_item'], '</b></div><br />', $txt['shop_send_items_message'], '
					<form action="', $scripturl, '?action=shop;do=senditems2" method="post">
						', $txt['shop_member_name'], ': <input type="text" name="membername" size="25" />
						<a href="', $scripturl, '?action=findmember;input=membername;quote=1;sesc=', $context['session_id'], '" onclick="return reqWin(this.href, 350, 400);"><img src="', $settings['images_url'], '/icons/assist.gif" border="0" alt="', $txt['find_members'], '" /> Find Members</a><br />			
						
						', $txt['shop_item_to_send'], ': <select name="giftid">', $context['shop_send_items'], '</select><br />
						', $txt['shop_send_message_to_give'], ': <textarea name="message" cols="50" rows="5"></textarea><br />
						<input type="submit" value="', $txt['shop_senditem'], '" />
					</form>
				</td>
			</tr>
		</table>';
	shop_footer();
}

?>
