<?php
// SMFShop uninstall script, version 2.3 (Build 11)
// $Date: 2006-12-08 16:00:09 +1100 (Fri, 08 Dec 2006) $
// $Id: installScript.php 39 2006-12-08 05:00:09Z daniel15 $

// Updated to not show errors if columns already exist


if (file_exists(dirname(__FILE__) . '/SSI.php') && !defined('SMF'))
	require_once(dirname(__FILE__) . '/SSI.php');
// Hmm... no SSI.php and no SMF?
elseif (!defined('SMF'))
	die('<b>Error:</b> Cannot install - please verify you put this in the same place as SMF\'s index.php.');

/*
 * The installer no longer checks to see if the installation is already done.
 * This is because the installer no longer produces an error if the shop stuff is already installed :)
 
 
 //check if the mods have already been done
$result = db_query("SELECT *
					FROM {$db_prefix}settings
					WHERE variable='shopVersion'
					LIMIT 1", __FILE__, __LINE__);


//if the shop version variable doesn't exist (ie. the database mods are needed)
if (mysql_num_rows($result) != 0) {
	$row = mysql_fetch_array($result, MYSQL_ASSOC);
	echo "The database is already installed, version ".$row['value']."!<br /><br />";
} else {
*/

	//create shop items table
	db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}shop_items (
			   `id` INT UNSIGNED NOT NULL AUTO_INCREMENT,
			   `name` VARCHAR(50) NOT NULL,
			   `desc` TEXT NOT NULL,
			   `price` DECIMAL(8,2) UNSIGNED NOT NULL,
			   `module` TINYTEXT NOT NULL,
			   `stock` SMALLINT NOT NULL,
			   `info1` TEXT NOT NULL,
			   `info2` TEXT NOT NULL,
			   `info3` TEXT NOT NULL,
			   `info4` TEXT NOT NULL,
			   `input_needed` TINYINT UNSIGNED DEFAULT '1' NOT NULL,
			   `can_use_item` TINYINT UNSIGNED DEFAULT '1' NOT NULL,
			   `image` TINYTEXT NOT NULL,
			   PRIMARY KEY (`id`) 
			   )", __FILE__, __LINE__);
	
	//create shop inventory table
	db_query("CREATE TABLE IF NOT EXISTS {$db_prefix}shop_inventory (
			  `id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
			  `ownerid` INT UNSIGNED NOT NULL ,
			  `itemid` INT UNSIGNED NOT NULL ,
			  `amtpaid` DECIMAL(8, 2) UNSIGNED DEFAULT '0.00' NOT NULL,
              `trading` TINYINT(1) UNSIGNED NOT NULL,
			  `tradecost` DECIMAL(8, 2) NOT NULL,
			  PRIMARY KEY (`id`)
			  )", __FILE__, __LINE__);
			  	
	//add settings (used in $modSettings array)
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopVersion', '2.3')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopDate', '21st October 2006')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopBuild', '11')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopCurrencyPrefix', '')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopCurrencySuffix', ' credits')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopPointsPerTopic', '10')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopPointsPerPost', '8')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopInterest', '2')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopBankEnabled', '1')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`,`value`) VALUES ('shopImageWidth', '32'), ('shopImageHeight', '32')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`, `value`) VALUES ('shopTradeEnabled', '1')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`, `value`) VALUES ('shopItemsPerPage', '10')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`, `value`) VALUES ('shopMinDeposit', '0')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`, `value`) VALUES ('shopMinWithdraw', '0')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}settings (`variable`, `value`) VALUES ('shopRegAmount', '0')", __FILE__, __LINE__);
	
	//SMFShop 1.0 items
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items ( `id` , `name` , `desc` , `price` , `module` , `stock` ) VALUES (
	'', 'Test Item', 'Just a test item!', '10.00', 'testitem', '50')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items ( `id` , `name` , `desc` , `price` , `module` , `stock` ) VALUES (
	'', 'Random Money', 'Get a random amount of money, between -190 and 190!', '75', 'RandomMoney', '50')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items ( `id` , `name` , `desc` , `price` , `module` , `stock` ) VALUES (
	'', 'Add 100 to Post Count', 'Increase your Post Count by 100!', '50', 'AddToPostCount', '50')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items ( `id` , `name` , `desc` , `price` , `module` , `stock` ) VALUES (
	'', 'Increase Karma', 'Increase your Karma by 5', '100', 'IncreaseKarma', '50')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items ( `id` , `name` , `desc` , `price` , `module` , `stock` ) VALUES (
	'', 'Change Username', 'Change your Username!', '50', 'ChangeUsername', '50')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items ( `id` , `name` , `desc` , `price` , `module` , `stock` ) VALUES (
	'', 'Change User Title', 'Change your User Title', '50', 'ChangeUserTitle', '50')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items ( `id` , `name` , `desc` , `price` , `module` , `stock` ) VALUES (
	'', 'Increase Total Time', 'Increase your total time logged in by 12 hours.', '50', 'IncreaseTimeLoggedIn', '50')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items ( `id` , `name` , `desc` , `price` , `module` , `stock` ) VALUES (
	'', 'Change Other\\'s Title',  'Change someone else\\'s title', '200', 'ChangeOtherTitle', '50')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items ( `id` , `name` , `desc` , `price` , `module` , `stock` ) VALUES (
	'', 'Decrease Posts by 100', 'Decrease <i>Someone else\\'s</i> post count by 100!!', '200', 'DecreasePost', '50')", __FILE__, __LINE__);
	
	//updating pre-1.1 items to 1.1 items
	db_query("UPDATE {$db_prefix}shop_items SET info1 = '100', input_needed = 0 WHERE module = 'AddToPostCount'", __FILE__, __LINE__);
	db_query("UPDATE {$db_prefix}shop_items SET info1 = '5', input_needed = 0 WHERE module = 'IncreaseKarma'", __FILE__, __LINE__);
	db_query("UPDATE {$db_prefix}shop_items SET info1 = '43200', input_needed = 0 WHERE module = 'IncreaseTimeLoggedIn'", __FILE__, __LINE__);
	db_query("UPDATE {$db_prefix}shop_items SET info1 = '-190', info2 = '190', input_needed = 0 WHERE module = 'RandomMoney'", __FILE__, __LINE__);
	db_query("UPDATE {$db_prefix}shop_items SET info1 = '40', input_needed = 1 WHERE module = 'Steal'", __FILE__, __LINE__);
	
	//SMFShop 1.1 items
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items VALUES ('', 'Steal Credits', 'Try to steal credits from another member!', 50, 'Steal', 50, '40', '', '', '', 1, 1, 'blank.gif')", __FILE__, __LINE__);
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items VALUES ('', 'Rock', 'Well.... It does nothing', 5, 'Rock', 50, '', '', '', '', 0, 0, 'blank.gif')", __FILE__, __LINE__);
	
	//SMFShop 1.2 items
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items (`name`, `desc`, `price`, `module`, `stock`, `input_needed`, `can_use_item`) VALUES (
	'Change Display Name', 'Change your display name!', 50.00, 'ChangeDisplayName', 49, 1, 1)", __FILE__, __LINE__);
	
	//SMFShop 2.1 items
	db_query("INSERT IGNORE INTO {$db_prefix}shop_items (`name`, `desc`, `price`, `module`, `stock`, `input_needed`, `can_use_item`) VALUES ('Sticky Topic', 'Make any one of your topics a sticky!', 400.00, 'StickyTopic', 50, 1, 1)", __FILE__, __LINE__);
	
	//default all items to use 'blank.gif'
	db_query("UPDATE {$db_prefix}shop_items SET image = 'blank.gif'", __FILE__, __LINE__);
	
	//add money columns to members table, if they don't already exist
	$result = db_query("SHOW COLUMNS FROM {$db_prefix}members LIKE 'money'", __FILE__, __LINE__);
	if (mysql_num_rows($result) == 0) 
		db_query("ALTER TABLE {$db_prefix}members ADD `money` DECIMAL(9, 2) UNSIGNED DEFAULT '0.00' NOT NULL", __FILE__, __LINE__);
		
	$result = db_query("SHOW COLUMNS FROM {$db_prefix}members LIKE 'moneyBank'", __FILE__, __LINE__);
	if (mysql_num_rows($result) == 0) 	
		db_query("ALTER TABLE {$db_prefix}members ADD `moneyBank` DECIMAL(9, 2) UNSIGNED DEFAULT '0.00' NOT NULL", __FILE__, __LINE__);
	
	//give admin money :-)
	db_query("UPDATE {$db_prefix}members SET `money` = '10000' WHERE `ID_MEMBER` = '1' LIMIT 1", __FILE__, __LINE__);
	
	//New field in boards table. This specifies whether credits is increased in this board or not.
	$result = db_query("SHOW COLUMNS FROM {$db_prefix}boards LIKE 'countMoney'", __FILE__, __LINE__);
	if (mysql_num_rows($result) == 0) 
		db_query("ALTER TABLE {$db_prefix}boards ADD `countMoney` TINYINT(1) UNSIGNED DEFAULT '1' NOT NULL", __FILE__, __LINE__);
	
	echo "<b><center>Installation of SMFShop 2.3 completed successfully!</center></b>";
//} 
?>
