<?php
/**********************************************\
| SMFSHOP (Shop MOD for Simple Machines Forum) |
|         (c) 2006 DanSoft Australia           |
|      http://www.dansoftaustralia.net/        |
\**********************************************/

//File: ShopAdmin.php
//	  Shop admin page

// VERSION: 2.3 (Build 11)
// $Date: 2006-10-21 13:34:18 +1000 (Sat, 21 Oct 2006) $
// $Id: ShopAdmin.php 24 2006-10-21 03:34:18Z daniel15 $

// If the file isn't called by SMF, it's bad!
if (!defined('SMF'))
	die('Hacking attempt...');

// During testing, caching was causing many problems. So, we try to disable the caching here
header("Expires: Fri, 1 Jun 1990 00:00:00 GMT"); //my birthday ;)
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Pragma: no-cache");

// Load the language file
loadLanguage('Shop');
// Check if they're allowed here
isAllowedTo('shop_admin');

// General shop administration page
function ShopGeneral() { 
	global $context, $modSettings, $txt;

	adminIndex('shop_general');

	// If they haven't saved yet
	if (empty($_GET['step']) || $_GET['step'] == 0) { 
		// If bank is enabled, check the box
		$context['shop_bank'] =  ($modSettings['shopBankEnabled'] == '1') ? ' checked' : '';
		// If trade centre is enabled, check the box
		$context['shop_trade'] =  ($modSettings['shopTradeEnabled'] == '1') ? ' checked' : '';
		// No message to show
		$context['shop_general'] = "";

	// If they've pressed the 'Save button'
	} elseif ($_GET['step'] == 1) {
		// Put all the settings into an array, to save
		$newSettings['shopCurrencyPrefix'] = $_POST['prefix'];
		$newSettings['shopCurrencySuffix'] = $_POST['suffix'];
		$newSettings['shopPointsPerTopic'] = (float) $_POST['pertopic'];
		$newSettings['shopPointsPerPost'] = (float) $_POST['perpost'];
		$newSettings['shopImageWidth'] = (int) $_POST['image_width'];
		$newSettings['shopImageHeight'] = (int) $_POST['image_height'];
		$newSettings['shopInterest'] = (int) $_POST['interest'];
		$newSettings['shopItemsPerPage'] = (int) $_POST['itemspage'];
		$newSettings['shopMinDeposit'] = (float) $_POST['minDeposit'];
		$newSettings['shopMinWithdraw'] = (float) $_POST['minWithdraw'];
		$newSettings['shopMinWithdraw'] = (int) $_POST['minWithdraw'];
		$newSettings['shopRegAmount'] = (int) $_POST['regamount'];
		
		
		$newSettings['shopBankEnabled'] = (isset($_POST['bankenabled'])) ? '1' : '0';
		$newSettings['shopTradeEnabled'] = (isset($_POST['tradeenabled'])) ? '1' : '0';

		// Save all these settings
		updateSettings($newSettings);
		
		// If bank is enabled, check the box
		$context['shop_bank'] =  ($modSettings['shopBankEnabled'] == '1') ? ' checked' : '';
		// If trade centre is enabled, check the box
		$context['shop_trade'] =  ($modSettings['shopTradeEnabled'] == '1') ? ' checked' : '';

		// Tell the user that settings were saved
		$context['shop_general'] = "Saved Changes!";
	}
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_admin_general'];
	// Load the template
	loadTemplate('ShopAdmin');
}

// Inventory administration
function ShopInventory() {
	global $context, $ID_MEMBER, $db_prefix, $txt, $scripturl;

	adminIndex('shop_inventory');

	// The main inventory page
	if (empty($_GET['do']) || $_GET['do'] == "") {
		// We need to do nothing, everything is handled by the template :-)
	// If we're viewing a user's inventory
	} else {
		
		// If we're deleting an item from the inventory
		if ($_GET['do'] == "delete") {
		
			// Make sure the ID is a number
			$_GET['id'] = (int) $_GET['id'];
			// Delete the actual item
			$result = db_query("DELETE
								FROM {$db_prefix}shop_inventory
								WHERE id = {$_GET['id']}
								LIMIT 1", __FILE__, __LINE__);
			// Tell the user that everything was OK :-)
			$context['shop_message'] = sprintf($txt['shop_deleted_item'], $_GET['id']);
	
		// If we're editing the user's money
		} elseif ($_GET['do'] == "editmoney") {

			// Check inputs were numbers
			$_POST['money_pocket'] = (float) $_POST['money_pocket'];
			$_POST['money_bank'] = (float) $_POST['money_bank'];
			$_POST['userid'] = (int) $_POST['userid'];
	
			// Update the user's details
			$result = db_query("UPDATE {$db_prefix}members
								SET money = {$_POST['money_pocket']},
									moneyBank = {$_POST['money_bank']}
								WHERE ID_MEMBER = {$_POST['userid']}
								LIMIT 1", __FILE__, __LINE__);
			// Tell the user that everthing worked find
			$context['shop_message'] = sprintf($txt['shop_changed_money'], $_POST['userid'], $_POST['money_pocket'], $_POST['money_bank']);
		}

		$context['shop_inventory_list'] = "";

		// Get the user's information
		$result = db_query("SELECT ID_MEMBER, money, moneyBank, memberName, realName
							FROM {$db_prefix}members
							WHERE memberName='{$_REQUEST['searchfor']}'
							LIMIT 1", __FILE__, __LINE__);

		// If this user doesn't exist
		if (mysql_num_rows($result) == 0) {
			$context['shop_inventory_search'] = 'message';
			// Show an error!
			$context['shop_message'] = sprintf($txt['shop_member_no_exist'], $_REQUEST['searchfor']);
		} else {
			// Get their information
			$row = mysql_fetch_array($result, MYSQL_ASSOC);
  
			// Get the user's ID
			$context['shop_member'] = $row['ID_MEMBER'];
			$context['shop_membername'] = $row['realName'];
			// And the amount of money they have
			$money_pocket = $row['money'];
			$money_bank = $row['moneyBank'];
  
			// Now, get their inventory
			$result = db_query("SELECT it.name, inv.amtpaid, inv.id
								FROM {$db_prefix}shop_inventory AS inv, {$db_prefix}shop_items AS it
								WHERE inv.ownerid = {$context['shop_member']}
									  AND inv.itemid = it.id
								ORDER BY inv.id",
								__FILE__, __LINE__);
  
			// Loop through all their inventory items
			while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
				// Add to the list 
				$context['shop_inventory_list'] .= "{$txt['shop_inventory']} #{$row['id']} - {$row['name']} - ".sprintf($txt['shop_bought_for'], $row['amtpaid'])." - <a href='$scripturl?action=shop_inventory;do=delete;id={$row['id']};searchfor={$_REQUEST['searchfor']}'>{$txt['shop_delete']}</a><br />";

			// Output the form section (with money)
			$context['shop_inventory_list'] .= "
  <br /><form action='$scripturl?action=shop_inventory;do=editmoney;searchfor={$_REQUEST['searchfor']}' method='post'>
	  <input type='hidden' name='userid' value='{$context['shop_member']}' />
	  {$txt['shop_money_in_pocket']}: <input type='text' value='{$money_pocket}' name='money_pocket' /><br />
	  {$txt['shop_money_in_bank']}: <input type='text' value='{$money_bank}' name='money_bank' /><br />
	  
	  <input type='submit' value='{$txt['shop_save_changes']}' />
  </form>";
			// The message at the top of the page 
			$context['shop_inv_message'] = sprintf($txt['shop_edit_member'], $context['shop_member'], $context['shop_membername']);
		}
	}
	
	// We need to load the inventory template
	$context['sub_template'] = "inventory";
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_admin_inventory'];
	// Load the administration template
	loadTemplate('ShopAdmin');
}

// Add an item to the shop
function ShopItemsAdd() {
	global $boarddir, $context, $db_prefix, $txt, $sourcedir, $scripturl;

	adminIndex('shop_items_add');
	// If we're on the first step (list items)
	if (empty($_GET['step']) || $_GET['step'] == 0) {
		// Heh, this has moved to the 'Edit Items' section
		// Well, we should redirect this confused user to the correct place :)
		header("Location: {$scripturl}?action=shop_items_edit");
		die();

	// Add item, step 1.
	// They've chosen an item, and clicked 'Next'. Prompt for input
	} elseif ($_GET['step'] == 1) {
		// Include the item engine 
		include "$sourcedir/shop/item_engine.php";
		// Include the actual item
		include "$sourcedir/shop/items/{$_POST['item']}.php";
		// Create an instance of the item
		eval("\$test = new item_{$_POST['item']};");
		// Get the item's details
		$test->getItemDetails();
		// Put all the details into an array
		$context['shop_items_item'] = array(
											'name' => $_POST['item'],
											'friendlyname' => $test->name,
											'desc' => $test->desc,
											'price' => $test->price,
											'stock' => 50,
											'require_input' => (int) $test->require_input,
											'can_use_item' => (int) $test->can_use_item,
											'authorName' => $test->authorName,
											'authorWeb' => $test->authorWeb,
											'authorEmail' => $test->authorEmail,
											);

		// Get the input required by the admin
		$theinput = "";
		$theinput = $test->getAddInput();
		// If some input is required, output all fields needed
		$context['shop_items_item']['getAddInput'] = ($theinput != "") ? "<br /><b>{$txt['shop_name_desc_match']}</b><br />{$theinput}<br />" : '';
	// Step 2... Input is all set, prepare to add item.
	} elseif ($_GET['step'] == 2) {
		
		// If item is not set, something is terribly wrong
		// Probably best to just exit
		if (!isset($_POST['item'])) die();

		// To avoid errors, check for non-existant values and set them to blank
		if (!isset($_POST['info1'])) $_POST['info1'] = "";
		if (!isset($_POST['info2'])) $_POST['info2'] = "";
		if (!isset($_POST['info3'])) $_POST['info3'] = "";
		if (!isset($_POST['info4'])) $_POST['info4'] = "";
		
		// If no image selected, default to 'blank.gif'
		if ($_POST['icon'] == "none") $_POST['icon'] = "blank.gif";

		// Check that numeric inputs are indeed numeric
		$_POST['itemprice'] = (float) $_POST['itemprice'];

		// The SQL query
		$sql = "INSERT
				INTO {$db_prefix}shop_items
				(name, `desc`, price, module, stock, input_needed, can_use_item, info1, info2, info3, info4, image)
				VALUES (
						'{$_POST['itemname']}',
						'{$_POST['itemdesc']}', 
						{$_POST['itemprice']}, 
						'{$_POST['item']}', 
						{$_POST['itemstock']},
						{$_POST['require_input']},
						{$_POST['can_use_item']},
						'{$_POST['info1']}',
						'{$_POST['info2']}',
						'{$_POST['info3']}',
						'{$_POST['info4']}',
						'{$_POST['icon']}'
						)";
		// Run the query
		$result = db_query($sql, __FILE__, __LINE__);
		// Return the item ID
		$itemID = db_insert_id();

		// We'd better redirect to the Edit Items page :)
		header("Location: {$scripturl}?action=shop_items_edit;do=add_success;id={$itemID}");
		die();
	}
	// We are loading the 'Add Items' template
	$context['sub_template'] = "items_add";
	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_admin_items_add'];
	// Load the template
	loadTemplate('ShopAdmin');
}

// Edit the shop items
function ShopItemsEdit() {
	global $context, $db_prefix, $txt, $scripturl, $sourcedir;

	adminIndex('shop_items_edit');

	// If we're editing something (they've clicked the 'Edit' link)
	if (isset($_GET['do']) && $_GET['do'] == "edit") {		
		// Make sure ID is numeric
		$_GET['id'] = (int) $_GET['id'];
		// Get the item's information
		$result = db_query("SELECT name, `desc`, price, stock, image
							FROM {$db_prefix}shop_items
							WHERE id = {$_GET['id']}"
							, __FILE__, __LINE__);
		$row = mysql_fetch_array($result, MYSQL_ASSOC);
		// Set all the information
		$context['shop_edit'] = array(
									  'id' => $_GET['id'],
									  'name' => $row['name'],
									  'desc' => $row['desc'],
									  'price' => $row['price'],
									  'stock' => $row['stock'],
									  'image' => $row['image'],
									   );

	// If they chose to delete an item
	} elseif (isset($_GET['do']) && $_GET['do'] == "del") {
		// If nothing was chosen to delete
		if (!isset($_POST['delete'])) die($txt['shop_item_delete_error']);

		// OK, we need to make an SQL statement to get all the item names
		// So, start the statement
		$sql = "SELECT id, name FROM {$db_prefix}shop_items WHERE id = ";
		// Now, add all the items passed
		$sql .= implode(' OR id = ', $_POST['delete']);
		// Finish the statement
		$sql .= " ORDER BY name ASC";

		// Now, run the SQL statement
		$result = db_query($sql, __FILE__, __LINE__);

		// Start with an empty list
		$context['shop_delete_list'] = "";
		
		// Loop through all the results
		while ($row = mysql_fetch_assoc($result)) {
			$context['shop_delete_list'] .= "<li><input type='hidden' name='delete[]' value='{$row['id']}' /> {$row['name']}</li>\n";
		} 

		// Pass the item ID(s) to the page
		$context['shop_delete'] = $_POST['delete'];
	} else {
		// If we're saving changes to the item
		if (isset($_GET['do']) && $_GET['do'] == "edit2") {
			// Make sure some inputs are numeric
			$_POST['id'] = (int) $_POST['id'];
			$_POST['itemprice'] = (float) $_POST['itemprice'];
			$_POST['itemstock'] = (int) $_POST['itemstock'];
			
			// Update the item information
			$result = db_query("UPDATE {$db_prefix}shop_items
								SET name = '{$_POST['itemname']}',
									`desc` = '{$_POST['itemdesc']}',
									price = {$_POST['itemprice']},
									stock = {$_POST['itemstock']},
									image = '{$_POST['icon']}'
								WHERE id = {$_POST['id']}
								LIMIT 1"
								, __FILE__, __LINE__);

		// This is used in the template for the message at the top
		$context['shop_edit_message'] = $txt['shop_saved'];

		// Actually deleting an item
		} elseif (isset($_GET['do']) && $_GET['do'] == "del2") {

			// If nothing was chosen to delete (shouldn't happen, but meh)
			if (!isset($_POST['delete'])) die($txt['shop_item_delete_error']);

			// Like with the 'del' action above, we need to make an SQL statement
			// So, start the statement
			$sql = "DELETE FROM {$db_prefix}shop_items WHERE id = ";
			// Now, add all the items passed
			$sql .= implode(' OR id = ', $_POST['delete']);

			// Run the SQL statement
			$result = db_query($sql, __FILE__, __LINE__);

			// If anyone owned this item, they don't anymore :P
			$sql = "DELETE FROM {$db_prefix}shop_inventory WHERE itemid = ";
			$sql .= implode(' OR itemid = ', $_POST['delete']);
			$result = db_query($sql, __FILE__, __LINE__);

			// This is used in the template for the message at the top
			$context['shop_edit_message'] = $txt['shop_deleted'];

		// If they've successfully added an item
		} elseif (isset($_GET['do']) && $_GET['do'] == 'add_success') {
			// Check if ID is numeric
			$_GET['id'] = (int) $_GET['id'];
			$context['shop_edit_message'] = $txt['shop_added_item'].' '.$_GET['id'];
		}


		// If we got here, it means that we're on the main page (or we returned to it
		// after an action such as deleting an item).
		
		// OK, the first bit of this is for adding items:
		// Include the 'item engine' (skeleton item, with defaults)
		include "$sourcedir/shop/item_engine.php";
		// Open the items directory
		if ($handle = opendir("$sourcedir/shop/items")) {
			// Loop through all files in the items directory
			while (false !== ($file = readdir($handle))) {
				// If this item is a PHP file, then...
				if (substr($file, -4) == ".php") {
					// Get the name (file name without .php extension)
					$name = basename($file, ".php");
					// Load this item
					include "$sourcedir/shop/items/$file";
	
					// Code to check if object exists, and if so, create new instance of object
					$code = "if (class_exists('item_$name')) {
								\$test = new item_$name;
								return true;
							} else {
								return false;
							}";
					// If we could create an instance of the item
					if (eval($code) !== FALSE) {
						// Get the item details
						$test->getItemDetails();
						// Add this item to the list
						$context['shop_items_item'][$test->name] = array(
																		'name' => $name,
																		'friendlyname' => $test->name,
																		'authorName' => $test->authorName,
																		'authorWeb' => $test->authorWeb,
																		'authorEmail' => $test->authorEmail,
																		);
					// Otherwise, this item is broken
					} else {
						// Inform the user of the sad news :P
						printf($txt['shop_item_error'], $name);
					}
				}
			}
			// Sort the array by key (ie. by item name)
			ksort($context['shop_items_item']);
		// Otherwise, there's a problem with the items directory
		} else {
			// Inform the user of this
			echo $txt['shop_cannot_open_items'];
		}
	
		// Now, for the edit items section:
		// Set item list to blank
		$context['shop_item_list'] = '';
		// Get a list of all the item
		$result = db_query("SELECT name, id FROM {$db_prefix}shop_items ORDER by name", __FILE__, __LINE__);
	
		// Loop through all the items
		while ($row = mysql_fetch_array($result, MYSQL_ASSOC))
			// Add this item to the list
			$context['shop_item_list'] .= "<input type='checkbox' name='delete[]' value='{$row['id']}'/> <b>{$row['name']}</b> - <a href='$scripturl?action=shop_items_edit;do=edit;id={$row['id']}'>{$txt['shop_edit']}</a><br />\n";
	}

	// Set the page title
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_admin_items_addedit'];
	// Tell the template what we want
	$context['sub_template'] = "items_edit";
	// Load the template
	loadTemplate('ShopAdmin');
}

// Restock any shop items
function ShopRestock() {
	global $boarddir, $context, $db_prefix, $txt;

	adminIndex('shop_restock');

	// If they pressed the button, update the stock
	if (isset($_GET['step']) && $_GET['step'] == 2) {
		$_POST['amount'] = (int) $_POST['amount'];
		$_POST['lessthan'] = (int) $_POST['lessthan'];

		db_query("UPDATE {$db_prefix}shop_items
				 SET stock = stock + {$_POST['amount']}
				 WHERE stock < {$_POST['lessthan']}", 
			     __FILE__, __LINE__);
	}
	
	loadTemplate('ShopAdmin');
	$context['sub_template'] = "restock";
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_admin_restock'];
}

// Shop membergroup functions
function ShopUserGroup() {
	global $boarddir, $context, $db_prefix, $txt;
	adminIndex('shop_usergroup');

	// If form wasn't submitted
	if (!isset($_GET['step']) || $_GET['step'] == 1) {
		// Start the select list
		$context['shop_usergroups'] = '<select name="usergroup">';

		// Get all non post-based membergroups
		$result = db_query("SELECT ID_GROUP, groupName
								FROM {$db_prefix}membergroups
								WHERE minPosts = -1",
							__FILE__, __LINE__);
	
		// For each membergroup, add it to the list
		while ($row = mysql_fetch_assoc($result))
			$context['shop_usergroups'] .= "<option value='{$row['ID_GROUP']}'>{$row['groupName']}</option>";

		// End the select list
		$context['shop_usergroups'] .= "</select>";

	// If the user has submitted the form
	} else {
		$action = ($_POST['m_action'] == 'sub') ? '-' : '+';
		// Make sure inputs were numeric
		$_POST['usergroup'] = (int) $_POST['usergroup'];
		$_POST['value'] = (float) $_POST['value'];
		// Do it!
		$result = mysql_query("UPDATE {$db_prefix}members SET money = money {$action} {$_POST['value']} WHERE ID_GROUP = {$_POST['usergroup']}");
}

	// Show actual page (load template)
	$context['sub_template'] = 'usergroup';
	$context['page_title'] = $txt['shop'].' - '.$txt['shop_admin_usergroup'];
	LoadTemplate('ShopAdmin');
}

// HELPER FUNCTIONS

// Echo a list of items to select
function echoSelectItem() {
	global $context;
	// Start the select list
	echo "<select name='item'>";

	// For every item in the current items list...
	foreach ($context['shop_items_item'] as $tempitem)
		//... add it as an option
		echo "<option value='{$tempitem['name']}'>{$tempitem['friendlyname']} by {$tempitem['authorName']} &lt;{$tempitem['authorEmail']}&gt;</option>\n";

	// Close the select
	echo "</select>";
}

// Echo a list of images to select from
// $defaultImage = The image to default to
function echoSelectImage($defaultImage = "blank.gif") {
	global $context, $boardurl, $txt, $modSettings, $boarddir;

	// Start with an empty array
	$context['shop_item_images'] = array();
	// Try to open the images directory
	if ($handle = opendir("$boarddir/Sources/shop/item_images")) {
		// For each file in the directory...
		while (false !== ($file = readdir($handle))) {
			// ...if it's a valid file, add it to the list
			if ($file !== "." && $file !== ".." && $file !== "blank.gif") $context['shop_item_images'][] = $file;
		}
		// Sort the list
		sort($context['shop_item_images']);
	// Otherwise, if directory inaccessible, show an error
	} else {
		echo $txt['shop_cannot_open_images'];
	}

	// Print out the JavaScript, and the initial part of the list
	echo "
		<script type='text/javascript' language='javascript'>
		<!--
		function show_image() {
			if (document.theAdminForm.icon.value !== 'none') {
				var image_url = '{$boardurl}/Sources/shop/item_images/' + document.theAdminForm.icon.value;
				document.images['icon'].src = image_url;
			} else {
				document.images['icon'].src = '{$boardurl}/Sources/shop/item_images/blank.gif';
			}
		}
		//-->
		</script>
		
		{$txt['shop_image']}: <img name='icon' src='{$boardurl}/Sources/shop/item_images/{$defaultImage}' border='1' width='{$modSettings['shopImageWidth']}' height='{$modSettings['shopImageHeight']}' alt='Item Image' />
		<select name='icon' onchange='show_image()'>";
	echo "<option value='blank.gif'", ($defaultImage == "blank.gif") ? ' selected="selected"' : '', ">[NONE]</option>\n";
	
	// Loop through all images
	foreach ($context['shop_item_images'] as $tempitem)
		// And add them to the dropdown list
		echo "<option value='{$tempitem}'", ($defaultImage == $tempitem) ? ' selected="selected"' : '', ">{$tempitem}</option>\n";
	// Close the <select>, and add comment at bottom
	echo "</select><br />{$txt['shop_item_notice']}";
}
?>
